#!/bin/bash

# Category : Development & Version Control
# Description : Ollama - Local AI Model Hosting (c/u/s/r/i):

installOllama()
{
    local config_variables="$1"

    if [[ "$ollama" == *[cCtTuUsSrRiI]* ]]; then
        dockerConfigSetupToContainer silent ollama;
        local app_name=$CFG_OLLAMA_APP_NAME
		initializeAppVariables $app_name;
    fi

    if [[ "$ollama" == *[cC]* ]]; then
        editAppConfig $app_name;
    fi

    if [[ "$ollama" == *[uU]* ]]; then
        dockerUninstallApp $app_name;
    fi

    if [[ "$ollama" == *[sS]* ]]; then
        dockerComposeDown $app_name;
    fi

    if [[ "$ollama" == *[rR]* ]]; then
        dockerComposeRestart $app_name;
    fi

    if [[ "$ollama" == *[iI]* ]]; then
        isHeader "Install $app_name"

		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up install config file for $app_name."
        echo ""

        dockerConfigSetupToContainer "loud" "$app_name" "install" "$config_variables";
        isSuccessful "Install config files have been setup for $app_name."

        ((menu_number++))
        echo ""


		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up the $app_name docker-compose.yml file."
        echo ""

        dockerComposeSetupFile $app_name;

        monitoringToggleAppConfig "$app_name" "docker-compose.yml";

		((menu_number++))
        echo ""
        echo "---- $menu_number. Updating file permissions before starting."
        echo ""

		fixPermissionsBeforeStart $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running the docker-compose.yml to install and start $app_name"
        echo ""

		dockerComposeUpdateAndStartApp $app_name install;

        ((menu_number++))
        echo ""
        echo "---- $menu_number. Running Application specific updates (if required)"
        echo ""

        appUpdateSpecifics $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running Headscale setup (if required)"
        echo ""

		setupHeadscale $app_name;

		((menu_number++))
		echo ""
        echo "---- $menu_number. Adding $app_name to the Apps Database table."
        echo ""

		databaseInstallApp $app_name;

		((menu_number++))
		echo ""
		echo "---- $menu_number. Updating WebUI config file."
		echo ""

		webuiContainerSetup $app_name install;

		((menu_number++))
		echo ""
		echo "---- $menu_number. Refreshing monitoring integration."
		echo ""

		monitoringRefreshAll;

		((menu_number++))
		echo ""
		echo "---- $menu_number. You can find $app_name files at $containers_dir$app_name"
        echo ""
        echo "    You can now navigate to your $app_name service using any of the options below : "
        echo ""

        menuShowFinalMessages $app_name;

		menu_number=0
        #sleep 3s
        cd
    fi
    ollama=n
}
